#!/bin/env python
'''
        To run this script, follow below steps:
        1) mkdir -p /home/oracle/.orachk_012518_163134/
        2) cp -r /oracle/oracheck/lib /home/oracle/.orachk_012518_163134/; cp -r /oracle/oracheck/build/Python2712 /home/oracle/.orachk_012518_163134/
        3) cp collndir/scripts/localcmd_018D62D990EE516DE05313C0E50A49DB_rac1.py /home/oracle/.orachk_012518_163134/
        4) /home/oracle/.orachk_012518_163134//build/Python2712/bin/python localcmd_018D62D990EE516DE05313C0E50A49DB_rac1.py
        '''
import sys
import os
sys.path.insert(0, '/home/oracle/.orachk_012518_163134/')
from lib.security import Secure
import lib.logger
_logger = lib.logger.Log()
_logger = _logger.set_logger("localcmd", '/oracle/oracheck/orachk_012518_163134/orachk.log', 'INFO', '')
secure = Secure(arg_logger = _logger)
import os, sys, re
from lib.utils import Utils
from lib.constant import Constants
Constants.PROGRAM_NAME = 'orachk'
Constants.FDS = '012518_163134'
os.environ['ORACLE_HOME'] = "/oracle/app/oracle/product/11.2.0/db"
os.environ['ORACLE_SID'] = "orcl1"
os.environ['CRS_HOME'] = "/oracle/app/11.2.0/grid"
os.environ['OUTPUTDIR'] = "/oracle/oracheck/orachk_012518_163134/"
os.environ['TMPDIR'] = "/home/oracle/.orachk_012518_163134/"
os.environ['RTEMPDIR'] = "/home/oracle/.orachk_012518_163134/"
if re.search(r'unset', os.environ.get('LD_LIBRARY_PATH','')): os.environ['LD_LIBRARY_PATH'] = ""
os.environ['LD_LIBRARY_PATH'] = os.environ.get('LD_LIBRARY_PATH', "") + ':' + os.environ.get('ORACLE_HOME', "") + os.path.sep + 'lib' + ':' + os.environ.get('CRS', "") + os.path.sep + 'lib'

ALVL = '''WARNING'''
native_code = '''chm_repo_size=$($CRS_HOME/bin/oclumon manage -get repsize|grep -iw size|awk \'{print $NF}\')
echo "$chm_repo_size"
echo DELIMCOM;node_names=$($CRS_HOME/bin/olsnodes)
number_of_nodes=$(echo "$node_names"|wc -w|tr -d \' \')
recommended_size=$( expr 867 \* 3 \* $number_of_nodes)
rep_location=$($CRS_HOME/bin/oclumon manage -get reppath|grep -wi path|awk \'{print $NF}\')
rep_location=$(dirname $rep_location)
least_space=0
for node_name in $node_names
do
     if  [ "$node_name" = "$(hostname|cut -d. -f1)"  ]
     then
            repo_size=$(df -k $rep_location|grep -vwi available|head -1|awk \'{print $4}\')
            least_space=$repo_size
            least_space_node=$node_name
     else
            repo_size=$(ssh $node_name  "df -k $rep_location")
            repo_size=$(echo "$repo_size"|grep -vwi available|head -1|awk \'{print $4}\')
     fi
     if [ $repo_size -lt $least_space ]; then least_space=$repo_size;least_space_node=$node_name;fi
done
least_space=$(expr $least_space / 1024)
chm_repo_size_hour=$(expr $chm_repo_size / 60 / 60)
echo -e "CHM repository size(hours) =  $chm_repo_size_hour\nRecommended size for CHM repository size(MB) = $recommended_size\ncluster node $least_space_node has least available space at $rep_location of $least_space MB"
if [ -n "$rat_exitcode" ]; then exit $rat_exitcode; else exit 0;fi
'''
(proc_out,proc_err,rat_exitcode) = secure.sync_subprocess(native_code, return_code_from_task = True, executable = '/bin/bash')
secure.logger.info((proc_out,proc_err,rat_exitcode))
proc_out2 = ''
try:
    proc_outval = proc_out.split("DELIMCOM")
    proc_out1 = proc_outval[0]
    proc_out2 = proc_outval[1]
    print proc_out1
except:
    print proc_out
fw = open('/oracle/oracheck/orachk_012518_163134/018D62D990EE516DE05313C0E50A49DB_rac1_report.out','a')
fw.write(proc_out2)
fw.close()
if ALVL is not None:
    localcmdval="ALVL = "+ALVL
if rat_exitcode is not None:
    sys.exit(rat_exitcode)
else:
    sys.exit(0)
