#!/bin/env python
'''
        To run this script, follow below steps:
        1) mkdir -p /home/oracle/.orachk_012518_163134/
        2) cp -r /oracle/oracheck/lib /home/oracle/.orachk_012518_163134/; cp -r /oracle/oracheck/build/Python2712 /home/oracle/.orachk_012518_163134/
        3) cp collndir/scripts/localcmd_48C202533F60ED96E0530B98EB0AC7CA_rac1.py /home/oracle/.orachk_012518_163134/
        4) /home/oracle/.orachk_012518_163134//build/Python2712/bin/python localcmd_48C202533F60ED96E0530B98EB0AC7CA_rac1.py
        '''
import sys
import os
sys.path.insert(0, '/home/oracle/.orachk_012518_163134/')
from lib.security import Secure
import lib.logger
_logger = lib.logger.Log()
_logger = _logger.set_logger("localcmd", '/oracle/oracheck/orachk_012518_163134/orachk.log', 'INFO', '')
secure = Secure(arg_logger = _logger)
import os, sys, re
from lib.utils import Utils
from lib.constant import Constants
Constants.PROGRAM_NAME = 'orachk'
Constants.FDS = '012518_163134'
os.environ['ORACLE_HOME'] = "/oracle/app/oracle/product/11.2.0/db"
os.environ['ORACLE_SID'] = "orcl1"
os.environ['CRS_HOME'] = "/oracle/app/11.2.0/grid"
os.environ['OUTPUTDIR'] = "/oracle/oracheck/orachk_012518_163134/"
os.environ['TMPDIR'] = "/home/oracle/.orachk_012518_163134/"
os.environ['RTEMPDIR'] = "/home/oracle/.orachk_012518_163134/"
if re.search(r'unset', os.environ.get('LD_LIBRARY_PATH','')): os.environ['LD_LIBRARY_PATH'] = ""
os.environ['LD_LIBRARY_PATH'] = os.environ.get('LD_LIBRARY_PATH', "") + ':' + os.environ.get('ORACLE_HOME', "") + os.path.sep + 'lib' + ':' + os.environ.get('CRS', "") + os.path.sep + 'lib'

ALVL = '''WARNING'''
native_code = '''# first determine if this is an Oracle Restart environment, do not run check unless it is
status=0
if [ -e  /etc/oracle/ocr.loc ]; then
       #location of ocr.loc for Linux and AIX
       #if the ocrconfig_loc is in the $CRS_HOME then this must be an Oracle Restart environment
       #if not then this must NOT be an Oracle Restart environment
       ocrstat=$(grep ocrconfig_loc /etc/oracle/ocr.loc|grep -c $CRS_HOME);
       if [ "$ocrstat" -eq "0" ]; then status=9196;fi
else
      #unable to locate ocr.loc file in the usual known locations so cannot positively ID Oracle Restart or RAC so we shouldn\'t run this check at all
      status=9196;
fi

numgipc=$(ps -ef |grep -v grep|grep -c \'gipcd.bin\')
numgpnp=$(ps -ef |grep -v grep|grep -c \'gpnpd.bin\')
if [[ "$numgipc" -gt "0" || "$numgpnp" -gt "0"  ]]; then
    # gipcd and/or gpnpd processes exist so must not be Oracle Restart, do not run the check at all
    status=9196;
fi
#end Oracle Restart check

if [ $status -eq 0 ]; then
   #if we make this far then it must be an Oracle Restart environment and we need to see that the cars_home = $GI_HOME (same as ohasd)
   olrpath=$(cat /etc/oracle/olr.loc|grep -i crs_home|cut -d= -f2);
   status=$(ps -ef|grep -v grep|grep ohasd.bin|grep -c $olrpath);
fi
echo $status
echo DELIMCOM;echo  -e "Clusterware home = $CRS_HOME\ncrs_home in olr.loc = $olrpath"
if [ -n "$rat_exitcode" ]; then exit $rat_exitcode; else exit 0;fi
'''
(proc_out,proc_err,rat_exitcode) = secure.sync_subprocess(native_code, return_code_from_task = True, executable = '/bin/bash')
secure.logger.info((proc_out,proc_err,rat_exitcode))
proc_out2 = ''
try:
    proc_outval = proc_out.split("DELIMCOM")
    proc_out1 = proc_outval[0]
    proc_out2 = proc_outval[1]
    print proc_out1
except:
    print proc_out
fw = open('/oracle/oracheck/orachk_012518_163134/48C202533F60ED96E0530B98EB0AC7CA_rac1_report.out','a')
fw.write(proc_out2)
fw.close()
if ALVL is not None:
    localcmdval="ALVL = "+ALVL
if rat_exitcode is not None:
    sys.exit(rat_exitcode)
else:
    sys.exit(0)
