#!/bin/env python
'''
        To run this script, follow below steps:
        1) mkdir -p /home/oracle/.orachk_012518_163134/
        2) cp -r /oracle/oracheck/lib /home/oracle/.orachk_012518_163134/; cp -r /oracle/oracheck/build/Python2712 /home/oracle/.orachk_012518_163134/
        3) cp collndir/scripts/localcmd_541B60EC65BC666BE0530A98EB0A2B7D_rac1.py /home/oracle/.orachk_012518_163134/
        4) /home/oracle/.orachk_012518_163134//build/Python2712/bin/python localcmd_541B60EC65BC666BE0530A98EB0A2B7D_rac1.py
        '''
import sys
import os
sys.path.insert(0, '/home/oracle/.orachk_012518_163134/')
from lib.security import Secure
import lib.logger
_logger = lib.logger.Log()
_logger = _logger.set_logger("localcmd", '/oracle/oracheck/orachk_012518_163134/orachk.log', 'INFO', '')
secure = Secure(arg_logger = _logger)
import os, sys, re
from lib.utils import Utils
from lib.constant import Constants
Constants.PROGRAM_NAME = 'orachk'
Constants.FDS = '012518_163134'
os.environ['ORACLE_HOME'] = "/oracle/app/oracle/product/11.2.0/db"
os.environ['ORACLE_SID'] = "orcl1"
os.environ['CRS_HOME'] = "/oracle/app/11.2.0/grid"
os.environ['OUTPUTDIR'] = "/oracle/oracheck/orachk_012518_163134/"
os.environ['TMPDIR'] = "/home/oracle/.orachk_012518_163134/"
os.environ['RTEMPDIR'] = "/home/oracle/.orachk_012518_163134/"
if re.search(r'unset', os.environ.get('LD_LIBRARY_PATH','')): os.environ['LD_LIBRARY_PATH'] = ""
os.environ['LD_LIBRARY_PATH'] = os.environ.get('LD_LIBRARY_PATH', "") + ':' + os.environ.get('ORACLE_HOME', "") + os.path.sep + 'lib' + ':' + os.environ.get('CRS', "") + os.path.sep + 'lib'

ALVL = '''WARNING'''
native_code = '''check_status=0
if [ -e  /etc/oracle/ocr.loc ]; then
       #location of ocr.loc for Linux and AIX
       ocrstat=$(grep ocrconfig_loc /etc/oracle/ocr.loc|grep -c $CRS_HOME)
elif  [ -e  /var/opt/oracle/ocr.loc ]; then
       #location of ocr.loc for HP-UX and Solaris
       ocrstat=$(grep ocrconfig_loc /var/opt/oracle/ocr.loc|grep -c $CRS_HOME)
else
      #unable to locate any ocr.loc file in the usual known locations so cannot positively ID Oracle Restart or RAC so we should not  run this check at all
     check_status=9196
fi

if [ "$ocrstat" -eq "0" ]; then status=9196;fi

numgipc=$(ps -ef |grep -v grep|grep -c \'gipcd.bin\')
numgpnp=$(ps -ef |grep -v grep|grep -c \'gpnpd.bin\')
if [[ "$numgipc" -gt "0" || "$numgpnp" -gt "0"  ]]; then
     check_status=9196
fi
#end Oracle Restart check

if [ $status -eq 0 ]; then
   report_command=$($CRS_HOME/bin/crsctl stat res -t|grep .svc)
   svc_count=$(echo -e "$report_command"|wc -l)
   if [ "$svc_count" -le "36" ]; then status=0;else status=1;fi
fi
echo $status
echo DELIMCOM;if [ -z "$report_command" ]; then report_command="No services found";fi
echo -e "$report_command"
if [ -n "$rat_exitcode" ]; then exit $rat_exitcode; else exit 0;fi
'''
(proc_out,proc_err,rat_exitcode) = secure.sync_subprocess(native_code, return_code_from_task = True, executable = '/bin/bash')
secure.logger.info((proc_out,proc_err,rat_exitcode))
proc_out2 = ''
try:
    proc_outval = proc_out.split("DELIMCOM")
    proc_out1 = proc_outval[0]
    proc_out2 = proc_outval[1]
    print proc_out1
except:
    print proc_out
fw = open('/oracle/oracheck/orachk_012518_163134/541B60EC65BC666BE0530A98EB0A2B7D_rac1_report.out','a')
fw.write(proc_out2)
fw.close()
if ALVL is not None:
    localcmdval="ALVL = "+ALVL
if rat_exitcode is not None:
    sys.exit(rat_exitcode)
else:
    sys.exit(0)
