#!/bin/env python
'''
        To run this script, follow below steps:
        1) mkdir -p /home/oracle/.orachk_012518_163134/
        2) cp -r /oracle/oracheck/lib /home/oracle/.orachk_012518_163134/; cp -r /oracle/oracheck/build/Python2712 /home/oracle/.orachk_012518_163134/
        3) cp collndir/scripts/localcmd_5673F46495DC24E3E053D298EB0A7F9C_rac1.py /home/oracle/.orachk_012518_163134/
        4) /home/oracle/.orachk_012518_163134//build/Python2712/bin/python localcmd_5673F46495DC24E3E053D298EB0A7F9C_rac1.py
        '''
import sys
import os
sys.path.insert(0, '/home/oracle/.orachk_012518_163134/')
from lib.security import Secure
import lib.logger
_logger = lib.logger.Log()
_logger = _logger.set_logger("localcmd", '/oracle/oracheck/orachk_012518_163134/orachk.log', 'INFO', '')
secure = Secure(arg_logger = _logger)
import os, sys, re
from lib.utils import Utils
from lib.constant import Constants
Constants.PROGRAM_NAME = 'orachk'
Constants.FDS = '012518_163134'
os.environ['ORACLE_HOME'] = "/oracle/app/oracle/product/11.2.0/db"
os.environ['ORACLE_SID'] = "orcl1"
os.environ['CRS_HOME'] = "/oracle/app/11.2.0/grid"
os.environ['OUTPUTDIR'] = "/oracle/oracheck/orachk_012518_163134/"
os.environ['TMPDIR'] = "/home/oracle/.orachk_012518_163134/"
os.environ['RTEMPDIR'] = "/home/oracle/.orachk_012518_163134/"
if re.search(r'unset', os.environ.get('LD_LIBRARY_PATH','')): os.environ['LD_LIBRARY_PATH'] = ""
os.environ['LD_LIBRARY_PATH'] = os.environ.get('LD_LIBRARY_PATH', "") + ':' + os.environ.get('ORACLE_HOME', "") + os.path.sep + 'lib' + ':' + os.environ.get('CRS', "") + os.path.sep + 'lib'

ALVL = '''WARNING'''
native_code = '''unset report_command
check_failed=0
status=0
hpt=$(cat /proc/meminfo|grep HugePages_Total:|awk \'{print $2}\')
if [ "$hpt" -eq "0" ] 
then
    status=9196;
else
    all_os_users=$(ps -ef |grep ora_pmon|grep -v grep|awk \'{print $2}\')
    for os_user in $(echo -e "$all_os_users")
    do  
       os_user=$(ps -o user= -p $os_user)
       is_same_user=$(echo -e "${all_os_usernames}"|grep -ic $os_user)
       if [ $is_same_user -eq 0 ];then  all_os_usernames=$(echo $all_os_usernames $os_user);fi
    done
    current_user=$(id|cut -d\'(\' -f2|cut -d\')\' -f1)
    current_user_id=$(id|cut -d= -f2|cut -d\'(\' -f1)
    recommended_value=90
    mt=$(cat /proc/meminfo|grep MemTotal:|awk \'{print $2}\')
    report_command=$(echo "$report_command\nTotal number of huge pages = $hpt\n")
    report_command=$(echo "$report_command\nTotal Memory = $mt\n")
    for os_user in $(echo -e "$all_os_usernames")
    do  
      if [ $current_user_id -eq 0 ] 
      then
          husrlimit=$(su - $os_user -c "ulimit -Hl"|tail -1|awk \'{print $NF}\')
          susrlimit=$(su - $os_user -c "ulimit -Sl"|tail -1|awk \'{print $NF}\')
          if [ "$husrlimit" != "unlimited" ];then smemlockpercent=$(echo "scale=2;($husrlimit / $mt * 100)"|bc|cut -d \. -f1);fi
          if [ "$susrlimit" != "unlimited" ];then hmemlockpercent=$(echo "scale=2;($susrlimit / $mt * 100)"|bc|cut -d \. -f1);fi
          if [ "$husrlimit" = "unlimited" ];then limit_status=0;elif [ $hmemlockpercent -ge $recommended_value ];then limit_status=0;else limit_status=1;fi
          if [ "$susrlimit" = "unlimited" ];then limit_status=0;elif [ $smemlockpercent -ge $recommended_value ];then limit_status=0;else limit_status=1;fi
          if [[ $check_failed -eq 0 && limit_status -eq 1 ]]
          then
              check_failed=1
              status=$limit_status
          fi  
          report_command=$(echo "$report_command\n$os_user user\'s hard memlock shell limit = $husrlimit and hard memlock % of total memory = $hmemlockpercent\n")
          report_command=$(echo "$report_command\n$os_user user\'s soft memlock shell limit = $susrlimit and soft memlock % of total memory = $hmemlockpercent\n")
      else
          if  [ "$current_user" = "$os_user" ]
          then
              husrlimit=$(ulimit -Hl)
              susrlimit=$(ulimit -Sl)
              if [ "$husrlimit" != "unlimited" ];then smemlockpercent=$(echo "scale=2;($husrlimit / $mt * 100)"|bc|cut -d \. -f1);fi
              if [ "$susrlimit" != "unlimited" ];then hmemlockpercent=$(echo "scale=2;($susrlimit / $mt * 100)"|bc|cut -d \. -f1);fi
              if [ "$husrlimit" = "unlimited" ];then limit_status=0;elif [ $hmemlockpercent -ge $recommended_value ];then limit_status=0;else limit_status=1;fi
              if [ "$susrlimit" = "unlimited" ];then limit_status=0;elif [ $smemlockpercent -ge $recommended_value ];then limit_status=0;else limit_status=1;fi
              report_command=$(echo "$report_command\n$os_user user\'s hard memlock shell limit = $husrlimit and hard memlock % of total memory = $hmemlockpercent\n")
              report_command=$(echo "$report_command\n$os_user user\'s soft memlock shell limit = $susrlimit and soft memlock % of total memory = $hmemlockpercent\n")
              status=$limit_status
          else
              report_command=$(echo "$report_command\n$current_user lacks permissions to check $os_user\'s  hard and soft memlock shell limits. root user can check shell limits for all users\n")
          fi
      fi  
    done
fi
echo $status
echo DELIMCOM;echo -e "$report_command"
if [ -n "$rat_exitcode" ]; then exit $rat_exitcode; else exit 0;fi
'''
(proc_out,proc_err,rat_exitcode) = secure.sync_subprocess(native_code, return_code_from_task = True, executable = '/bin/bash')
secure.logger.info((proc_out,proc_err,rat_exitcode))
proc_out2 = ''
try:
    proc_outval = proc_out.split("DELIMCOM")
    proc_out1 = proc_outval[0]
    proc_out2 = proc_outval[1]
    print proc_out1
except:
    print proc_out
fw = open('/oracle/oracheck/orachk_012518_163134/5673F46495DC24E3E053D298EB0A7F9C_rac1_report.out','a')
fw.write(proc_out2)
fw.close()
if ALVL is not None:
    localcmdval="ALVL = "+ALVL
if rat_exitcode is not None:
    sys.exit(rat_exitcode)
else:
    sys.exit(0)
