#!/bin/env python
'''
        To run this script, follow below steps:
        1) mkdir -p /home/oracle/.orachk_012518_163134/
        2) cp -r /oracle/oracheck/lib /home/oracle/.orachk_012518_163134/; cp -r /oracle/oracheck/build/Python2712 /home/oracle/.orachk_012518_163134/
        3) cp collndir/scripts/localcmd_5C413530675BC12CE053D498EB0A3C84_rac1.py /home/oracle/.orachk_012518_163134/
        4) /home/oracle/.orachk_012518_163134//build/Python2712/bin/python localcmd_5C413530675BC12CE053D498EB0A3C84_rac1.py
        '''
import os
import sys
sys.path.insert(0, '/home/oracle/.orachk_012518_163134/')
from lib.security import Secure
import lib.logger
_logger = lib.logger.Log()
_logger = _logger.set_logger("localcmd", '/oracle/oracheck/orachk_012518_163134/orachk.log', 'INFO', '')
secure = Secure(arg_logger = _logger)
import os, sys, re
from lib.utils import Utils
from lib.constant import Constants
Constants.PROGRAM_NAME = 'orachk'
Constants.FDS = '012518_163134'
os.environ['CRS_HOME'] = "/oracle/app/11.2.0/grid"
os.environ['OUTPUTDIR'] = "/oracle/oracheck/orachk_012518_163134/"
os.environ['TMPDIR'] = "/home/oracle/.orachk_012518_163134/"
os.environ['RTEMPDIR'] = "/home/oracle/.orachk_012518_163134/"
if re.search(r'unset', os.environ.get('LD_LIBRARY_PATH','')): os.environ['LD_LIBRARY_PATH'] = ""
os.environ['LD_LIBRARY_PATH'] = os.environ.get('LD_LIBRARY_PATH', "") + ':' + os.environ.get('ORACLE_HOME', "") + os.path.sep + 'lib' + ':' + os.environ.get('CRS', "") + os.path.sep + 'lib'
os.environ["ORACLE_SID"] = 'orcl1'
os.environ["ORACLE_HOME"] = '/oracle/app/oracle/product/11.2.0/db'

ALVL = '''FAIL'''
native_code = '''v_is_loc_shared=1
if [ -e /bin/awk ] ; then
 v_awk=/bin/awk
elif [ -e /usr/xpg4/bin/awk ] ; then
 v_awk=/usr/xpg4/bin/awk
else
 v_awk=awk
fi

# get the db snapcf config info
v_snapcf_loc=$(echo -e "set heading off feedback off linesize 500 timing off \nselect distinct value from v\$rman_configuration where name=\'SNAPSHOT CONTROLFILE NAME\';"|$ORACLE_HOME/bin/sqlplus -s "/ as sysdba" | $v_awk -F"\'" \'{print $2}\' | tr -d \' \')

# get the hosts on which this db\'s instances are running
v_hosts=$(echo -e "set heading off feedback off linesize 500 timing off \nselect distinct host_name from gv\$instance;"|$ORACLE_HOME/bin/sqlplus -s "/ as sysdba" | tr -d \' \')
v_hosts_cvu=$(echo $v_hosts | sed \'s/[\t ]/,/g\')

# Check if the db snapshot controlfile configuration exists
if [[  -n "$v_snapcf_loc" ]] ; then

  v_snapcf_dirname=$(dirname $v_snapcf_loc)

  # get the storage location type: / means file system, + means in ASM
  v_snapcf_loc_type=$(echo $v_snapcf_dirname | $v_awk \'{print substr($0,1,1)}\')

  # check if the location is not empty and on a file system
  if [[  -n "$v_snapcf_loc_type" ]] && [[ "$v_snapcf_loc_type" = "/" ]] ; then
   # cvu to validate shared storageness 
    cvu_report_command=$($ORACLE_HOME/bin/cluvfy comp ssa -s $v_snapcf_dirname -n $v_hosts_cvu -display_status 2>&1)

   # check the status of last command. 0 means pass 
    if [[ $(echo $?) -eq 0 ]] ; then
      v_is_loc_shared=0
      report_command=$(echo "${report_command}\nSnapshot Controlfile is on Shared Filesystem/Directory: $v_snapcf_dirname")
      report_command=$(echo "${report_command}\n $cvu_report_command")
    else
      v_is_loc_shared=1
      report_command=$(echo "${report_command}\nSnapshot Controlfile is not on Shared Filesystem/Directory: $v_snapcf_dirname")
      report_command=$(echo "${report_command}\n $cvu_report_command")
    fi

  else
    # on ASM
    v_is_loc_shared=0
    report_command=$(echo "${report_command}\nSnapshot Controlfile is on ASM Disk Group/Directory: $v_snapcf_dirname")
  fi
else
 v_is_loc_shared=1
 report_command=$(echo "${report_command}\nSnapshot Controlfile is not created because: select distinct value from v\$rman_configuration where name=\'SNAPSHOT CONTROLFILE NAME\' did not return any value.")
fi

echo $v_is_loc_shared
echo DELIMCOM;echo "$report_command"
if [ -n "$rat_exitcode" ]; then exit $rat_exitcode; else exit 0;fi
'''
(proc_out,proc_err,rat_exitcode) = secure.sync_subprocess(native_code, return_code_from_task = True, executable = '/bin/bash')
secure.logger.info((proc_out,proc_err,rat_exitcode))
proc_out2 = ''
try:
    proc_outval = proc_out.split("DELIMCOM")
    proc_out1 = proc_outval[0]
    proc_out2 = proc_outval[1]
    print proc_out1
except:
    print proc_out
fw = open('/oracle/oracheck/orachk_012518_163134/5C413530675BC12CE053D498EB0A3C84_rac1_report.out','a')
fw.write(proc_out2)
fw.close()
if ALVL is not None:
    localcmdval="ALVL = "+ALVL
if rat_exitcode is not None:
    sys.exit(rat_exitcode)
else:
    sys.exit(0)
